<%@ PAGE LANGUAGE="C#" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Drawing" %>
<html>
<head>
<script runat="server">
string[] colorNames =
	{ "Black", "Blue", "Red", "Magenta", "Green", "Cyan", "Yellow", "White" };
string[] colorNamesBG =
	{ "transparent", "Black", "Blue", "Red", "Magenta", "Green", "Cyan", "Yellow", "White" };

void Page_Load(object sender, EventArgs e) {
	if (!IsPostBack) {
		ICollection ds = CreateDataSource();
		datagrid.DataSource = ds;

		gridlines.DataSource = Enum.GetNames(typeof(GridLines));
		halign.DataSource = Enum.GetNames(typeof(HorizontalAlign));
		forecolor.DataSource = colorNames;
		backcolor.DataSource = colorNamesBG;
		bordercolor.DataSource = colorNames;
		borderstyle.DataSource = Enum.GetNames(typeof(BorderStyle));

		item_halign.DataSource = Enum.GetNames(typeof(HorizontalAlign));
		item_valign.DataSource = Enum.GetNames(typeof(VerticalAlign));
		item_wrap.DataSource = new string[] { "true", "false" };
		item_forecolor.DataSource = colorNames;
		item_backcolor.DataSource = colorNamesBG;
		item_bordercolor.DataSource = colorNames;
		item_borderstyle.DataSource = Enum.GetNames(typeof(BorderStyle));

		DataBind();
	} else {
		/*
			WebControl.StyleŒ`vpeB
		*/
		Style s = new Style();

		s.ForeColor = Color.FromName(forecolor.SelectedItem.Text);
		s.BackColor = Color.FromName(backcolor.SelectedItem.Text);
		s.BorderColor = Color.FromName(bordercolor.SelectedItem.Text);
		s.BorderStyle = (BorderStyle) Enum.Parse(typeof(BorderStyle), borderstyle.SelectedItem.Text);

		try { s.BorderWidth = Int32.Parse(borderwidth.Text); }
		catch (Exception ex) { s.BorderWidth = Unit.Empty; }

		try { s.Height = Int32.Parse(height.Text); }
		catch (Exception ex) { s.Height = Unit.Empty; }

		try { s.Width = Int32.Parse(width.Text); }
		catch (Exception ex) { s.Width = Unit.Empty; }

		try { s.Font.Name = font.Text; }
		catch (Exception ex) { s.Font.Name = String.Empty; }

		datagrid.ApplyStyle(s);

		/*
			TableStyleƂĒ`ĂvpeB
		*/
		datagrid.GridLines = (GridLines) Enum.Parse(typeof(GridLines), gridlines.SelectedItem.Text);
		datagrid.HorizontalAlign = (HorizontalAlign) Enum.Parse(typeof(HorizontalAlign), halign.SelectedItem.Text);
		try { datagrid.CellPadding = Int32.Parse(cellpadding.Text); }
		catch (Exception ex) { datagrid.CellPadding = -1; }
		try { datagrid.CellSpacing = Int32.Parse(cellspacing.Text); }
		catch (Exception ex) { datagrid.CellSpacing = 0; }
		
		/*
			TableItemStyleƂĒ`ĂvpeB
		*/
		TableItemStyle tis = datagrid.ItemStyle;

		tis.ForeColor = Color.FromName(item_forecolor.SelectedItem.Text);
		tis.BackColor = Color.FromName(item_backcolor.SelectedItem.Text);
		tis.BorderColor = Color.FromName(item_bordercolor.SelectedItem.Text);
		tis.BorderStyle = (BorderStyle) Enum.Parse(typeof(BorderStyle), item_borderstyle.SelectedItem.Text);

		try { tis.BorderWidth = Int32.Parse(item_borderwidth.Text); }
		catch (Exception ex) { tis.BorderWidth = Unit.Empty; }
		try { tis.Height = Int32.Parse(item_height.Text); }
		catch (Exception ex) { tis.Height = Unit.Empty; }
		try { tis.Width = Int32.Parse(item_width.Text); }
		catch (Exception ex) { tis.Width = Unit.Empty; }
		try { tis.Font.Name = item_font.Text; }
		catch (Exception ex) { tis.Font.Name = String.Empty; }

		tis.HorizontalAlign = (HorizontalAlign) Enum.Parse(typeof(HorizontalAlign), item_halign.SelectedItem.Text);
		tis.VerticalAlign = (VerticalAlign) Enum.Parse(typeof(VerticalAlign), item_valign.SelectedItem.Text);
		tis.Wrap = Boolean.Parse(item_wrap.SelectedItem.Text);
	}
}

ICollection CreateDataSource() {
	DirectoryInfo di = new DirectoryInfo(Server.MapPath("."));
	FileInfo[] fi = di.GetFiles();

	DataTable dt = new DataTable();
	DataRow dr;

	dt.Columns.Add(new DataColumn("fileid", typeof(int)));
	dt.Columns.Add(new DataColumn("filename", typeof(String)));
	dt.Columns.Add(new DataColumn("filesize", typeof(long)));
	dt.Columns.Add(new DataColumn("date", typeof(DateTime)));

	for (int i = 0; i < fi.Length; i++) {
		dr = dt.NewRow();
		dr[0] = i;
		dr[1] = fi[i].Name;
		dr[2] = fi[i].Length;
		dr[3] = fi[i].LastWriteTime;
		dt.Rows.Add(dr);
	}

	DataView dv = new DataView(dt);

	return dv;
}
</script>
<style>
div.box	{
	border-style: solid;
	border-width: 3px;
	padding: 4px;
	margin: 4px;
}

td.even	{
	color: black;
	background-color: #ffffcc;
}

td.odd	{
	color: black;
	background-color: #ffff66;
}
</style>
</head>
<body>
<form runat="server">

<table rules="rows">
<tr><td align="center" colspan="6">TableStyle</td></tr>
<tr>
<td> CellPadding </td><td> <asp:TextBox id="cellpadding" runat="server" /> </td>
<td> CellSpacing </td><td> <asp:TextBox id="cellspacing" runat="server" /> </td>
<td></td><td></td>
</tr>
<tr>
<td> GridLines </td><td> <asp:DropDownList id="gridlines" runat="server" /> </td>
<td> HorizontalAlign </td><td> <asp:DropDownList id="halign" runat="server" /> </td>
<td></td><td></td>
</tr>
<tr>
<td> ForeColor </td><td> <asp:DropDownList id="forecolor" runat="server" /> </td>
<td> BackColor </td><td> <asp:DropDownList id="backcolor" runat="server" /> </td>
<td></td>
<td></td>
</tr>
<tr>
<td> BorderColor </td><td> <asp:DropDownList id="bordercolor" runat="server" /> </td>
<td> BorderStyle </td><td> <asp:DropDownList id="borderstyle" runat="server" /> </td>
<td> BorderWidth </td><td> <asp:TextBox id="borderwidth" runat="server" /> </td>
</tr>
<td> Height </td><td> <asp:TextBox id="height" runat="server" /> </td>
<td> Width </td><td> <asp:TextBox id="width" runat="server" /> </td>
<td> Font </td><td> <asp:TextBox id="font" runat="server" /> </td>
</tr>
</table>

<hr>

<table rules="rows">
<tr><td align="center" colspan="6">TableItemStyle</td></tr>
<tr>
<td> HorizontalAlign </td><td> <asp:DropDownList id="item_halign" runat="server" /></td>
<td> VerticalAlign </td><td> <asp:DropDownList id="item_valign" runat="server" /> </td>
<td> Wrap </td><td> <asp:DropDownList id="item_wrap" runat="server" /> </td>
</tr>
<tr>
<td> ForeColor </td><td> <asp:DropDownList id="item_forecolor" runat="server" /> </td>
<td> BackColor </td><td> <asp:DropDownList id="item_backcolor" runat="server" /> </td>
<td></td>
<td></td>
</tr>
<tr>
<td> BorderColor </td><td> <asp:DropDownList id="item_bordercolor" Enabled="false" runat="server" /> </td>
<td> BorderStyle </td><td> <asp:DropDownList id="item_borderstyle" Enabled="false" runat="server" /> </td>
<td> BorderWidth </td><td> <asp:TextBox id="item_borderwidth" Enabled="false" runat="server" /> </td>
</tr>
<td> Height </td><td> <asp:TextBox id="item_height" Enabled="false" runat="server" /> </td>
<td> Width </td><td> <asp:TextBox id="item_width" Enabled="false" runat="server" /> </td>
<td> Font </td><td> <asp:TextBox id="item_font" runat="server" /> </td>
</tr>
</table>

<asp:Button Text="XV" runat="server" />
<hr>
<div class="box">
<asp:DataGrid id="datagrid" AutoGenerateColumns="false" runat="server">
	<Columns>
	<asp:BoundColumn HeaderText="t@C" DataField="filename" />
	<asp:BoundColumn HeaderText="TCY" DataField="filesize" />
	<asp:BoundColumn HeaderText="XV" DataField="date" />
	</Columns>
</asp:DataGrid>
</div>
</form>
</body>
</html>
